from __future__ import with_statement
import es
import cfglib
import playerlib
import popuplib
import os
import langlib
import gamethread
import threading
import cPickle
from configobj import ConfigObj


apath = es.getAddonPath('skinchooser')
config = cfglib.AddonCFG(apath + "/settings.cfg")
sc_force = config.cvar("sc_force", "!skins", "Set the Command to open the SkinMenu")
sc_set_force = config.cvar("sc_set_force", "!setskin", "Set the Command to open the SkinMenu")
sc_saveindatabase = config.cvar("sc_saveindatabase", 1, "0 = Disable, 1 = Here you can set that the Skins will be saved in databse(So it will be thre for all spawns)")
sc_admins_allow = config.cvar("sc_admins_allow", 1, "0 = Disable, 1 = Allow Admins to choose Skins")
sc_ct_allow = config.cvar("sc_ct_allow", 1, "0 = Disable, 1 = Allow Normal CounterTerroists to choose Skins")
sc_t_allow = config.cvar("sc_t_allow", 1, "0 = Disable, 1 = Allow Normal Terrorists to choose Skins")
sc_admins = config.cvar("sc_admins", "STEAM_0:1:5432453,STEAM_0:1:12345678", "Set the Admins (split by comma if you want to add more)")
sc_showmodelin3d = config.cvar("sc_showmodelin3d", 1, "0 = Disable, 1 = The model will be shown on spawn and on choose in 3rd Person")
sc_thirdpersontime = config.cvar("sc_thirdpersontime", 3, "Set the time how long the thirdpersonview goes")
sc_allowmsg = config.cvar("sc_allowmsg", 1, "0 = Disable, 1 = Allow the Advert How to set skin")
config.write()

Skinchooser = dict()


################################Addon Infos##########################################
info = es.AddonInfo()                                                               #
info.name          = 'SkinChooser'                                                  #
info.version       = '1.0 D'                                                        #
info.basename      = 'skin_chooser'                                                 #
info.url           = 'http://addons.eventscripts.com/addons/view/SkinChooser'       #
info.author        = 'RoOF'                                                         #
es.ServerVar(info.basename, info.version, 'SkinChooser').makepublic()               #
#####################################################################################



models_t = ConfigObj(apath + '/models_terrorist.ini')
models_admin_t = ConfigObj(apath + '/models_admin_terrorist.ini')
models_admin_ct = ConfigObj(apath + '/models_admin_counterterrorist.ini')
models_ct = ConfigObj(apath + '/models_counterterrorist.ini')
lock = threading.Lock()

def load():
	global Skinchooser, text
	config.execute()
	text = langlib.Strings(apath + '/strings.ini')
	if sc_saveindatabase:
		database_sc = apath + '/skindatabase.db'
		if os.path.isfile(database_sc):
			with lock:
				file_players = open(database_sc)
				Skinchooser = cPickle.load(file_players)
				file_players.close() 
	if es.getString('eventscripts_currentmap'):
		download()
		
def unload():
	if not sc_saveindatabase:
		Skinchooser.clear()
	else:
		save()
		
def es_map_start(ev):
	download()
			
def player_activate(ev):
	steam = ev['es_steamid']
	if es.isbot(ev['userid']):
		return
	if steam not in Skinchooser:
		Skinchooser[steam] = {}
			
def player_say(ev):
	userid = ev['userid']
	if ev['text'] == sc_force:
		modelfeatures(userid)
	if ev['text'] == sc_set_force:
		if ev['es_steamid'] in str(sc_admins).split(','):
			voteSet(userid)
		else:
			es.tell(userid, '#multi', '#green[SkinChooser][Admin] You are not Allowed to Use that Command')
		
def player_spawn(ev):
	steam = ev['es_steamid']
	userid = int(ev['userid'])
	team = es.getplayerteam(userid)
	player = playerlib.getPlayer(userid)
	if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
		if steam in Skinchooser:
			if team == 2:
				if steam in str(sc_admins).split(','):
					if sc_admins_allow:
						if 'TAdminchoice' in Skinchooser[steam]:
							playerlib.getPlayer(userid).setModel(Skinchooser[steam]['TAdminchoice'])
							showmodel(userid)
							es.tell(userid, '#multi', text('skin',{'v1': Skinchooser[steam]['TAdminname']},player.get('lang')))
				else:
					if sc_t_allow:
						if 'Tchoice' in Skinchooser[steam]:
							playerlib.getPlayer(userid).setModel(Skinchooser[steam]['Tchoice'])
							showmodel(userid)
							es.tell(userid, '#multi', text('skin',{'v1': Skinchooser[steam]['Tname']},player.get('lang')))
			else:
				if steam in str(sc_admins).split(','):
					if sc_admins_allow:
						if 'CTAdminchoice' in Skinchooser[steam]:
							playerlib.getPlayer(userid).setModel(Skinchooser[steam]['CTAdminchoice'])
							showmodel(userid)
							es.tell(userid, '#multi', text('skin',{'v1': Skinchooser[steam]['CTAdminname']},player.get('lang')))
				else:
					if sc_ct_allow:
						if 'CTchoice' in Skinchooser[steam]:
							playerlib.getPlayer(userid).setModel(Skinchooser[steam]['CTchoice'])
							showmodel(userid)
							es.tell(userid, '#multi', text('skin',{'v1': Skinchooser[steam]['CTname']},player.get('lang')))
					
					
def showmodel(userid):
	if sc_showmodelin3d:
		if not es.getplayerprop(userid, "CCSPlayer.baseclass.pl.deadflag"):
			gamethread.delayed(0.5, es.setplayerprop,(userid, "CBasePlayer.m_hObserverTarget", 0))
			gamethread.delayed(0.5, es.setplayerprop,(userid, "CBasePlayer.m_iObserverMode", 1))
			gamethread.delayed(0.5, es.setplayerprop,(userid, "CBasePlayer.localdata.m_Local.m_bDrawViewmodel", 0))
			gamethread.delayed(0.5, es.setplayerprop,(userid, "CBasePlayer.m_iFOV", 120))
			gamethread.delayed(sc_thirdpersontime, es.setplayerprop,(userid, "CBasePlayer.m_iObserverMode", 0))
			gamethread.delayed(sc_thirdpersontime, es.setplayerprop,(userid, "CBasePlayer.localdata.m_Local.m_bDrawViewmodel", 1))
			gamethread.delayed(sc_thirdpersontime, es.setplayerprop,(userid, "CBasePlayer.m_iFOV", 90))


def modelfeatures(userid):
	global skinMenu
	steam = es.getplayersteamid(userid)
	skinMenu = popuplib.easymenu('skinMenu', None, selectskin)
	team = es.getplayerteam(userid)
	if team == 2:
		if sc_admins_allow:
			if steam in str(sc_admins).split(','):
				if steam in Skinchooser:
					if 'TAdminname' in Skinchooser[steam]:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: [ "+str(Skinchooser[steam]['TAdminname'])+" ]\nFor Admins\nFor Terrorist Team")
						skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Admins\nFor Terrorist Team")
					for x in models_admin_t:
						skinMenu.addoption((models_admin_t[x]['path'], x), x)

			else:
				if sc_t_allow:
					if steam in Skinchooser:
						if 'Tname' in Skinchooser[steam]:
							skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: [ "+str(Skinchooser[steam]['Tname'])+" ]\nFor Terrorist Team")
							skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
						else:
							skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
						for x in models_t:
							skinMenu.addoption((models_t[x]['path'], x), x)
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
						for x in models_t:
							skinMenu.addoption((models_t[x]['path'], x), x)
		else:
			if sc_t_allow:
				if steam in Skinchooser:
					if 'Tname' in Skinchooser[steam]:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: [ "+str(Skinchooser[steam]['Tname'])+" ]\nFor Terrorist Team")
						skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
					for x in models_t:
						skinMenu.addoption((models_t[x]['path'], x), x)
				else:
					skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
					for x in models_t:
						skinMenu.addoption((models_t[x]['path'], x), x)

	elif team == 3:
		if sc_admins_allow:
			if steam in str(sc_admins).split(','):
				if steam in Skinchooser:
					if 'CTAdminname' in Skinchooser[steam]:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: [ "+str(Skinchooser[steam]['CTAdminname'])+" ]\nFor Admins\nFor CounterTerrorist Team")
						skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Admins\nFor CounterTerrorist Team")
					for x in models_admin_ct:
						skinMenu.addoption((models_admin_ct[x]['path'], x), x)
			else:
				if sc_ct_allow:
					if steam in Skinchooser:
						if 'CTname' in Skinchooser[steam]:
							skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: [ "+str(Skinchooser[steam]['CTname'])+" ]\nFor CounterTerrorist Team")
							skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
						else:
							skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor CounterTerrorist Team")
						for x in models_ct:
							skinMenu.addoption((models_ct[x]['path'], x), x)
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
						for x in models_ct:
							skinMenu.addoption((models_ct[x]['path'], x), x)
		else:
			if sc_ct_allow:
				if steam in Skinchooser:
					if 'CTname' in Skinchooser[steam]:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: [ "+str(Skinchooser[steam]['CTname'])+" ]\nFor CounterTerrorist Team")
						skinMenu.addoption(('Noskin', "Delete Your Current Skin"),"Delete Your Current Skin")
					else:
						skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor CounterTerrorist Team")
					for x in models_ct:
						skinMenu.addoption((models_ct[x]['path'], x), x)
				else:
					skinMenu.settitle("->SkinChooser:\nYour Current Selected Skin: None\nFor Terrorist Team")
					for x in models_ct:
						skinMenu.addoption((models_ct[x]['path'], x), x)
	skinMenu.send(userid)
	
def player_team(ev):
	t = threading.Thread(target=save)
	t.start()
	
def round_start(ev):
	if sc_allowmsg:
		for x in es.getUseridList():
			es.tell(x, '#multi', text('adverts',{'v1': sc_force},playerlib.getPlayer(x).get('lang')))
	
def round_end(ev):
	t = threading.Thread(target=save)
	t.start()
	
	



def selectskin(userid, choice, popupid):
	es.playsound(userid, "buttons/button14.wav", 1.0)
	team = es.getplayerteam(userid)
	steam = es.getplayersteamid(userid)
	player = playerlib.getPlayer(userid)
	if choice[1] == 'Delete Your Current Skin':
		if steam in Skinchooser:
			if 'TAdminchoice' in Skinchooser[steam]:
				del Skinchooser[steam]['TAdminchoice']
				del Skinchooser[steam]['TAdminname']
				player.setModel('player/t_phoenix')
				es.tell(userid, '#multi', text('skindeleted',{},player.get('lang')))
			elif 'Tchoice' in Skinchooser[steam]:
				del Skinchooser[steam]['Tchoice']
				del Skinchooser[steam]['Tname']
				player.setModel('player/t_phoenix')
				es.tell(userid, '#multi', text('skindeleted',{},player.get('lang')))
			elif 'CTAdminchoice' in Skinchooser[steam]:
				del Skinchooser[steam]['CTAdminchoice']
				del Skinchooser[steam]['CTAdminname']
				player.setModel('player/ct_sas')
				es.tell(userid, '#multi', text('skindeleted',{},player.get('lang')))
			elif 'CTchoice' in Skinchooser[steam]:
				del Skinchooser[steam]['CTchoice']
				del Skinchooser[steam]['CTname']
				player.setModel('player/ct_sas')
				es.tell(userid, '#multi', text('skindeleted',{},player.get('lang')))
	else:
		player.setModel(choice[0])
		if team == 2:
			if steam in str(sc_admins).split(','):
				Skinchooser[steam]['TAdminchoice'] = choice[0]
				Skinchooser[steam]['TAdminname'] = choice[1]
				es.tell(userid, '#multi', text('skin2',{'v1': choice[1]},player.get('lang')))
			else:
				Skinchooser[steam]['Tchoice'] = choice[0]
				Skinchooser[steam]['Tname'] = choice[1]
				es.tell(userid, '#multi', text('skin2',{'v1': choice[1]},player.get('lang')))
		elif team == 3:
			if steam in str(sc_admins).split(','):
				Skinchooser[steam]['CTAdminchoice'] = choice[0]
				Skinchooser[steam]['CTAdminname'] = choice[1]
				es.tell(userid, '#multi', text('skin2',{'v1': choice[1]},player.get('lang')))
			else:
				Skinchooser[steam]['CTchoice'] = choice[0]
				Skinchooser[steam]['CTname'] = choice[1]
				es.tell(userid, '#multi', text('skin2',{'v1': choice[1]},player.get('lang')))
	showmodel(userid)
	
def selectskin2(userid, choice, popupid):
	es.playsound(userid, "buttons/button14.wav", 1.0)
	steam = es.getplayersteamid(choice[3])
	player = playerlib.getPlayer(choice[3])
	if choice[0] == 'Delete his Current Skin':
		if steam in Skinchooser:
			if choice[2] == '[HasSkin] Terrorist':
				if 'Tchoice' in Skinchooser[steam]:
					del Skinchooser[steam]['Tchoice']
					del Skinchooser[steam]['Tname']
					player.setModel('player/t_phoenix')
					es.tell(userid, '#multi', text('skindeleted',{},player.get('lang')))
			elif choice[2] == '[HasSkin] CounterTerrorist':
				if 'CTchoice' in Skinchooser[steam]:
					del Skinchooser[steam]['CTchoice']
					del Skinchooser[steam]['CTname']
					player.setModel('player/ct_sas')
					es.tell(userid, '#multi', text('skindeleted',{},player.get('lang')))
	else:
		player.setModel(choice[0])
		if choice[2] == '[NoSkin] Terrorist':
			Skinchooser[steam]['Tchoice'] = choice[0]
			Skinchooser[steam]['Tname'] = choice[1]
			es.tell(userid, '#multi', text('skin2',{'v1': choice[1]},player.get('lang')))
			if es.getplayerteam(choice[3]) == 2:
				showmodel(choice[3])
				es.tell(choice[3], '#multi', text('adminset',{'v1': choice[1],'team': 'Terrorist'},player.get('lang')))
		elif choice[2] == '[NoSkin] CounterTerrorist':
			Skinchooser[steam]['CTchoice'] = choice[0]
			Skinchooser[steam]['CTname'] = choice[1]
			es.tell(userid, '#multi', text('skin2',{'v1': choice[1]},player.get('lang')))
			if es.getplayerteam(choice[3]) == 3:
				showmodel(choice[3])
				es.tell(choice[3], '#multi', text('adminset',{'v1': choice[1],'team': 'CounterTerrorist'},player.get('lang')))
	voteSet(userid)
	
	
def player_disconnect(ev):
	if sc_saveindatabase:
		if ev['networkid'] in Skinchooser:
			t = threading.Thread(target=save)
			t.start()
		
def download():
	if os.path.isfile(apath + '/downloads.cfg'):
		for a in r_download():
			es.stringtable('downloadables', a)
			
def r_download():
	if os.path.isfile(apath + '/downloads.cfg'):
		a = open(apath + '/downloads.cfg', 'r')
		b = a.readlines()
		a.close()
		return map(lambda x: x.replace('\n', '').replace('\\', '/').replace('downloadable', ''), filter(lambda x: not x.startswith('//') and not x == '\n' and len(x) >= 10, b))
					
def save():
	with lock:
		file_players = open(apath + '/skindatabase.db','w')
		cPickle.dump(Skinchooser, file_players)
		file_players.close()
		
def voteSet(userid):
	name = 'setskin_menu'
	if popuplib.exists(name):
		popuplib.delete(name)
	setskinmenu = popuplib.easymenu(name, '_popup_choice', select_team)
	setskinmenu.settitle('SkinChooser:\nFor Admins\nSet Skins For the Players:')
	for player in es.getUseridList():
		setskinmenu.addoption((player,es.getplayername(player)),es.getplayername(player))
	setskinmenu.send(userid)
	
def select_team(userid, choice, popupid):
	name = 'setskin_menu2'
	if popuplib.exists(name):
		popuplib.delete(name)
	setskinmenu2 = popuplib.easymenu(name, '_popup_choice', select_sk)
	setskinmenu2.settitle('SkinChooser:\nFor Admins\nSet Skins For thek Players:')
	steam = es.getplayersteamid(choice[0])
	player = choice[0]
	if steam in Skinchooser:
		if 'Tchoice' in Skinchooser[steam]:
			setskinmenu2.addoption((player,'[HasSkin] Terrorist'),'[HasSkin] Terrorist')
		else:
			setskinmenu2.addoption((player,'[NoSkin] Terrorist'),'[NoSkin] Terrorist')
		if 'CTchoice' in Skinchooser[steam]:
			setskinmenu2.addoption((player,'[HasSkin] CounterTerrorist'),'[HasSkin] CounterTerrorist')
		else:
			setskinmenu2.addoption((player,'[NoSkin] CounterTerrorist'),'[NoSkin] CounterTerrorist')
	setskinmenu2.send(userid)

	
def select_sk(userid, choice, popupid):
	steam = es.getplayersteamid(choice[0])
	global setskinMenu3
	setskinMenu3 = popuplib.easymenu('setskinMenu3', None, selectskin2)
	setskinMenu3.settitle('SkinChooser:\nFor Admins\nSet Skins For the Players:')
	v = []
	if steam in Skinchooser:
		if 'Tchoice' in Skinchooser[steam] or 'CTchoice' in Skinchooser[steam]:
			setskinMenu3.addoption(('Delete his Current Skin', 'Delete his Current Skin', choice[1], choice[0]),'Delete his Current Skin')
	for x in models_ct:
		if x in v:
			continue
		v.append(x)
		setskinMenu3.addoption((models_ct[x]['path'], x, choice[1], choice[0]), x)
	for x in models_t:
		if x in v:
			continue
		v.append(x)
		setskinMenu3.addoption((models_t[x]['path'], x, choice[1], choice[0]), x)
	for x in models_admin_ct:
		if x in v:
			continue
		v.append(x)
		setskinMenu3.addoption((models_admin_ct[x]['path'], x, choice[1], choice[0]), x)
	for x in models_admin_t:
		if x in v:
			continue
		v.append(x)
		setskinMenu3.addoption((models_admin_t[x]['path'], x, choice[1], choice[0]), x)
	setskinMenu3.send(userid)